### Apache HTTP Server Version 1.3

Is this the version you want? For more recent versions, check our documentation index.

# Apache Core Features

These configuration parameters control the core Apache features, and are always available.

## Directives

- AcceptFilter
- AcceptMutex
- AccessConfig
- AccessFileName
- AddDefaultCharset
- AddModule
- AllowOverride
- AuthName
- AuthDigestRealmSeed
- AuthType
- BindAddress
- BS2000Account
- CGICommandArgs
- ClearModuleList
- ContentDigest
- CoreDumpDirectory
- DefaultType
- <Directory>
- <DirectoryMatch>
- DocumentRoot
- EBCDICConvert
- EBCDICConvertByType
- EBCDICKludge
- EnableExceptionHook
- ErrorDocument
- ErrorLog
- FileETag
- <Files>
- <FilesMatch>
- Group
- HostnameLookups
- IdentityCheck
- <IfDefine>
- <IfModule>
- Include
- KeepAlive
- KeepAliveTimeout
- <Limit>
- <LimitExcept>
- LimitInternalRecursion
- LimitRequestBody
- LimitRequestFields
- LimitRequestFieldsize
- LimitRequestLine
- Listen
- ListenBacklog
- <Location>
- <LocationMatch>
- LockFile
- LogLevel
- MaxClients
- MaxKeepAliveRequests
- MaxRequestsPerChild
- MaxSpareServers
- MinSpareServers
- NameVirtualHost
- Options
- PidFile
- Port
- ProtocolReqCheck
- Require
- ResourceConfig
- RLimitCPU
- RLimitMEM
- RLimitNPROC
- Satisfy
- ScoreBoardFile
- ScriptInterpreterSource
- SendBufferSize
- ServerAdmin
- ServerAlias
- ServerName
- ServerPath
- ServerRoot
- ServerSignature
- ServerTokens
- ServerType
- ShmemUIDisUser
- StartServers
- ThreadsPerChild
- ThreadStackSize
- TimeOut
- TraceEnable
- UseCanonicalName
- User
- <VirtualHost>

## AcceptFilter directive

Syntax: AcceptFilter on|off
Default: `AcceptFilter on`
Context: server config
Status: core
Compatibility: AcceptFilter is available in Apache 1.3.22 and later

`AcceptFilter` controls a BSD specific filter optimization. It is compiled in by default - and switched on by default if your system supports it (setsocketopt() option SO_ACCEPTFILTER). Currently only FreeBSD supports this.

See the filter section on performance hints for more information.

The compile time flag `AP_ACCEPTFILTER_OFF` can be used to change the default to 'off'. `httpd -V` and `httpd -L` will show compile time defaults and whether or not SO_ACCEPTFILTER was defined during the compile.

## AcceptMutex directive

Syntax: AcceptMutex uslock|pthread|sysvsem|fcntl|flock|os2sem|tpfcore|none|default
Default: `AcceptMutex default`
Context: server config
Status: core
Compatibility: AcceptMutex is available in Apache 1.3.21 and later.

`AcceptMutex` controls which accept() mutex method Apache will use. Not all methods are available on all platforms, since the suite of methods is determined at compile-time. For a list of which methods are available for your particular build, the `httpd -V` command line option will list them out.

The compile time flags `-D HAVE_METHOD_SERIALIZED_ACCEPT` can be used to add different methods to your build, or one can edit the `include/ap_config.h` file for your particular platform.

This directive has no effect on Microsoft Windows.

See the performance tuning guide for more information.

## AccessConfig directive

Syntax: AccessConfig file-path|directory-path|wildcard-path
Default: `AccessConfig conf/access.conf`
Context: server config, virtual host
Status: core
Compatibility: The ability to specify a directory, rather than a file name, is only available in Apache 1.3.13 and later. This directive will be eliminated in version 2.0.

The server will read this file for more directives after reading the ResourceConfig file. File-path is relative to the ServerRoot. This feature can be disabled using:

> `AccessConfig /dev/null`

Or, on Win32 servers,

> `AccessConfig nul`

Historically, this file only contained <Directory> sections; in fact it can now contain any server directive allowed in the server config context. However, since Apache version 1.3.4, the default `access.conf` file which ships with Apache contains only comments, and all directives are placed in the main server configuration file, `httpd.conf`.

If `AccessConfig` points to a directory, rather than a file, Apache will read all files in that directory, and any subdirectory, and parse those as configuration files.

Alternatively you can use a wildcard to limit the scope; i.e to only *.conf files.

Note that by default any file in the specified directory will be loaded as a configuration file.

So make sure that you don't have stray files in this directory by mistake, such as temporary files created by your editor, for example.

See also: Include and ResourceConfig.

## AccessFileName directive

Syntax: AccessFileName filename [filename] ...
Default: `AccessFileName .htaccess`
Context: server config, virtual host
Status: core
Compatibility: AccessFileName can accept more than one filename only in Apache 1.3 and later

When returning a document to the client the server looks for the first existing access control file from this list of names in every directory of the path to the document, if access control files are enabled for that directory. For example:

> `AccessFileName .acl`

before returning the document /usr/local/web/index.html, the server will read /.acl, /usr/.acl, /usr/local/.acl and /usr/local/web/.acl for directives, unless they have been disabled with

> `<Directory />
> AllowOverride None
> </Directory>`

See Also: AllowOverride and Configuration Files

## AddDefaultCharset directive

Syntax: AddDefaultCharset On|Off|charset
Context: all
Status: core
Default: `AddDefaultCharset Off`
Compatibility: AddDefaultCharset is only available in Apache 1.3.12 and later

This directive specifies the name of the character set that will be added to any response that does not have any parameter on the content type in the HTTP headers. This will override any character set specified in the body of the document via a `META` tag. A setting of `AddDefaultCharset Off` disables this functionality. `AddDefaultCharset On` enables Apache's internal default charset of `iso-8859-1` as required by the directive. You can also specify an alternate charset to be used.

For example:

> `AddDefaultCharset utf-8`

Note: This will not have any effect on the Content-Type and character set for default Apache-generated status pages (such as '404 Not Found' or '301 Moved Permanently') because those have an actual character set (that in which the hard-coded page content is written) and don't need to have a default applied.

## AddModule directive

Syntax: AddModule module [module] ...
Context: server config
Status: core
Compatibility: AddModule is only available in Apache 1.2 and later

The server can have modules compiled in which are not actively in use. This directive can be used to enable the use of those modules. The server comes with a pre-loaded list of active modules; this list can be cleared with the ClearModuleList directive.

For example:

> `AddModule mod_include.c`

The ordering of `AddModule` lines is important. Modules are listed in reverse priority order --- the ones that come later can override the behavior of those that come earlier. This can have visible effects; for instance, if UserDir followed Alias, you couldn't alias out a particular user's home directory. For more information and a recommended ordering, see `src/Configuration.tmpl` in the Apache source distribution.

See also: ClearModuleList and LoadModule

## AllowOverride directive

Syntax: AllowOverride All|None|directive-type [directive-type] ...
Default: `AllowOverride All`
Context: directory
Status: core

When the server finds an .htaccess file (as specified by AccessFileName) it needs to know which directives declared in that file can override earlier access information.

Note: `AllowOverride` is only valid in <Directory> sections, not in <Location> or <Files> sections, as implied by the Context section above.

When this directive is set to `None`, then .htaccess files are completely ignored. In this case, the server will not even attempt to read .htaccess files in the filesystem.

When this directive is set to `All`, then any directive which has the .htaccess Context is allowed in .htaccess files.

The directive-type can be one of the following groupings of directives.

AuthConfig
  Allow use of the authorization directives (AuthDBMGroupFile, AuthDBMUserFile, AuthGroupFile, AuthName, AuthDigestRealmSeed, AuthType, AuthUserFile, Require, etc.).
FileInfo
  Allow use of the directives controlling document types (AddEncoding, AddLanguage, AddType, DefaultType, ErrorDocument, LanguagePriority, etc.).
Indexes
  Allow use of the directives controlling directory indexing (AddDescription, AddIcon, AddIconByEncoding, AddIconByType, DefaultIcon, DirectoryIndex, FancyIndexing, HeaderName, IndexIgnore, IndexOptions, ReadmeName, etc.).
Limit
  Allow use of the directives controlling host access (Allow, Deny and Order).
Options
  Allow use of the directives controlling specific directory features (Options and XBitHack).

Example:

> `AllowOverride AuthConfig Indexes`

See Also: AccessFileName and Configuration Files

## AuthName directive

Syntax: AuthName auth-domain
Context: directory, .htaccess
Override: AuthConfig
Status: core

This directive sets the name of the authorization realm for a directory. This realm is given to the client so that the user knows which username and password to send. `AuthName` takes a single argument; if the realm name contains spaces, it must be enclosed in quotation marks. It must be accompanied by AuthType and Require directives, and directives such as AuthUserFile and AuthGroupFile to work.

For example:

> `AuthName "Top Secret"`

The string provided for the `AuthName` is what will appear in the password dialog provided by most browsers.

See also: Authentication, Authorization, and Access Control

## AuthDigestRealmSeed directive

Syntax: AuthDigestRealmSeed secret-real-string
Context: directory, .htaccess
Override: AuthConfig
Status: core

This directive sets a per realm secret nonce prefix which is used to ensure that a captured username, password and realm string during a Digest exchange cannot be replayed at other places.

It only applies to mod_digest.html, the experimental mod_auth_digest.html implements its own (more advanced and also time sensitive) replay protection.

It must be accompanied by AuthType of type Digest, one or more Require directives, and directives such as AuthUserFile and AuthGroupFile to work.

See also: Authentication, Authorization, and Access Control

## AuthType directive

Syntax: AuthType Basic|Digest
Context: directory, .htaccess
Override: AuthConfig
Status: core

This directive selects the type of user authentication for a directory. Only `Basic` and `Digest` are currently implemented. It must be accompanied by AuthName and Require directives, and directives such as AuthUserFile and AuthGroupFile to work.

When AuthDigest is used an AuthDigestRealmSeed should also be set.

See also: Authentication, Authorization, and Access Control

## BindAddress directive

Syntax: BindAddress *|IP-address|domain-name
Default: `BindAddress *`
Context: server config
Status: core
Compatibility: BindAddress is deprecated and will be eliminated in Apache 2.0.

A Unix® http server can either listen for connections to every IP address of the server machine, or just one IP address of the server machine. If the argument to this directive is *, then the server will listen for connections on every IP address. Otherwise, the server can listen to only a specific IP-address or a fully-qualified Internet domain-name.

For example:

`BindAddress 192.168.15.48`

Only one `BindAddress` directive can be used.

This directive is deprecated and will be eliminated in Apache 2.0. Equivalent functionality and more control over the address and ports Apache listens to is available using the `Listen` directive.

`BindAddress` can be used as an alternative method for supporting virtual hosts using multiple independent servers, instead of using `<VirtualHost>` sections.

See Also: DNS Issues
See Also: Setting which addresses and ports Apache uses

## BS2000Account directive

Syntax: BS2000Account account
Default: none
Context: server config
Status: core
Compatibility: BS2000Account is only available for BS2000 machines, as of Apache 1.3 and later.

The `BS2000Account` directive is available for BS2000 hosts only. It must be used to define the account number for the non-privileged apache server user (which was configured using the User directive). This is required by the BS2000 POSIX subsystem (to change the underlying BS2000 task environment by performing a sub-LOGON) to prevent CGI scripts from accessing resources of the privileged account which started the server, usually `SYSROOT`.
Only one `BS2000Account` directive can be used.

See Also: Apache EBCDIC port

## CGICommandArgs directive

Syntax: CGICommandArgs On|Off
Default: CGICommandArgs On
Context: directory, .htaccess
Override: Options
Status: core
Compatibility: Available in Apache 1.3.24 and later.

Way back when the internet was a safer, more naive place, it was convenient for the server to take a query string that did not contain an '=' sign and to parse and pass it to a CGI program as command line args. For example, `<IsIndex>` generated searches often work in this way. The default behavior in Apache is to maintain this behavior for backwards compatibility, although it is generally regarded as unsafe practice today. Most CGI programs do not take command line parameters, but among those that do, many are unaware of this method of passing arguments and are therefore vulnerable to malicious clients passing unsafe material in this way. Setting `CGICommandArgs Off` is recommended to protect such scripts with little loss in functionality.

## ClearModuleList directive

Syntax: ClearModuleList
Context: server config
Status: core
Compatibility: ClearModuleList is only available in Apache 1.2 and later

The server comes with a built-in list of active modules. This directive clears the list. It is assumed that the list will then be re-populated using the AddModule directive.

See also: AddModule and LoadModule

## ContentDigest directive

Syntax: ContentDigest on|off
Default: `ContentDigest off`
Context: server config, virtual host, directory, .htaccess
Override: Options
Status: experimental
Compatibility: ContentDigest is only available in Apache 1.1 and later

This directive enables the generation of `Content-MD5` headers as defined in RFC1864 respectively RFC2068.

MD5 is an algorithm for computing a "message digest" (sometimes called "fingerprint") of arbitrary-length data, with a high degree of confidence that any alterations in the data will be reflected in alterations in the message digest.

The `Content-MD5` header provides an end-to-end message integrity check (MIC) of the entity-body. A proxy or client may check this header for detecting accidental modification of the entity-body in transit. Example header:

       Content-MD5: AuLb7Dp1rqtRtxz2m9kRpA==

Note that this can cause performance problems on your server since the message digest is computed on every request (the values are not cached).

`Content-MD5` is only sent for documents served by the core, and not by any module. For example, SSI documents, output from CGI scripts, and byte range responses do not have this header.

## CoreDumpDirectory directive

Syntax: CoreDumpDirectory directory-path
Default: the same location as ServerRoot
Context: server config
Status: core

This controls the directory to which Apache attempts to switch before dumping core. The default is in the ServerRoot directory, however since this should not be writable by the user the server runs as, core dumps won't normally get written. If you want a core dump for debugging, you can use this directive to place it in a different location.

For example:

> `CoreDumpDirectory /tmp`

## DefaultType directive

Syntax: DefaultType MIME-type
Default: `DefaultType text/plain`
Context: server config, virtual host, directory, .htaccess
Override: FileInfo
Status: core

There will be times when the server is asked to provide a document whose type cannot be determined by its MIME types mappings.

The server must inform the client of the content-type of the document, so in the event of an unknown type it uses the `DefaultType`. For example:

> `DefaultType image/gif`

would be appropriate for a directory which contained many gif images with filenames missing the .gif extension.

See also: AddType and TypesConfig.

## <Directory> directive

Syntax: <Directory directory-path|proxy:url-path> ... </Directory>
Context: server config, virtual host
Status: Core.

<Directory> and </Directory> are used to enclose a group of directives which will apply only to the named directory and sub-directories of that directory. Any directive which is allowed in a directory context may be used. Directory-path is either the full path to a directory, or a wild-card string. In a wild-card string, `?' matches any single character, and `*' matches any sequences of characters. As of Apache 1.3, you may also use `[ ]' character ranges like in the shell. Also as of Apache 1.3 none of the wildcards match a `/' character, which more closely mimics the behavior of Unix shells. Example:

       <Directory /usr/local/httpd/htdocs>
       Options Indexes FollowSymLinks
       </Directory>

Apache 1.2 and above: Extended regular expressions can also be used, with the addition of the `~` character. For example:

       <Directory ~ "^/www/.*/[0-9]{3}">

would match directories in /www/ that consisted of three numbers.

If multiple (non-regular expression) directory sections match the directory (or its parents) containing a document, then the directives are applied in the order of shortest match first, interspersed with the directives from the .htaccess files. For example, with

> `<Directory />
> AllowOverride None
> </Directory>
> <Directory /home/*>
> AllowOverride FileInfo
> </Directory>`

for access to the document `/home/web/dir/doc.html` the steps are:

- Apply directive `AllowOverride None` (disabling `.htaccess` files).
- Apply directive `AllowOverride FileInfo` (for directory `/home/web`).
- Apply any FileInfo directives in `/home/web/.htaccess`

Regular expression directory sections are handled slightly differently by Apache 1.2 and 1.3. In Apache 1.2 they are interspersed with the normal directory sections and applied in the order they appear in the configuration file. They are applied only once, and apply when the shortest match possible occurs. In Apache 1.3 regular expressions are not considered until after all of the normal sections have been applied. Then all of the regular expressions are tested in the order they appeared in the configuration file. For example, with

> `<Directory ~ abc$>
> ... directives here ...
> </Directory>
> `

Suppose that the filename being accessed is `/home/abc/public_html/abc/index.html`. The server considers each of `/`, `/home`, `/home/abc`, `/home/abc/public_html`, and `/home/abc/public_html/abc` in that order. In Apache 1.2, when `/home/abc` is considered, the regular expression will match and be applied. In Apache 1.3 the regular expression isn't considered at all at that point in the tree. It won't be considered until after all normal <Directory>s and `.htaccess` files have been applied. Then the regular expression will match on `/home/abc/public_html/abc` and be applied.

Note that the default Apache access for <Directory /> is `Allow from All`. This means that Apache will serve any file mapped from an URL. It is recommended that you change this with a block such as

     <Directory />
         Order Deny,Allow
         Deny from All
     </Directory>

and then override this for directories you want accessible. See the Security Tips page for more details.

<Directory> directives cannot nest, and cannot appear in a <Limit> or <LimitExcept> section.

If you have mod_proxy enabled, you can use the `proxy:` syntax to apply configuration directives to proxied content. The syntax for this is to specify the proxied URLs to which you wish to apply the configuration, or to specify `*` to apply to all proxied content:

To apply to all proxied content:

       <Directory proxy:*>
         ... directives here ...
       </Directory>

To apply to just a subset of proxied content:

       <Directory proxy:http://www.example.com/>
         ... directives here ...
       </Directory>

See also: How Directory, Location and Files sections work for an explanation of how these different sections are combined when a request is received

See also: DirectoryMatch

## <DirectoryMatch>

Syntax: <DirectoryMatch regex> ... </DirectoryMatch>
Context: server config, virtual host
Status: Core.
Compatibility: Available in Apache 1.3 and later

<DirectoryMatch> and </DirectoryMatch> are used to enclose a group of directives which will apply only to the named directory and sub-directories of that directory, the same as <Directory>. However, it takes as an argument a regular expression. For example:

       <DirectoryMatch "^/www/.*/[0-9]{3}">

would match directories in /www/ that consisted of three numbers.

See Also: <Directory> for a description of how regular expressions are mixed in with normal <Directory>s.
See also: How Directory, Location and Files sections work for an explanation of how these different sections are combined when a request is received

## DocumentRoot directive

Syntax: DocumentRoot directory-path
Default: `DocumentRoot /usr/local/apache/htdocs`
Context: server config, virtual host
Status: core

This directive sets the directory from which httpd will serve files. Unless matched by a directive like Alias, the server appends the path from the requested URL to the document root to make the path to the document. Example:

> `DocumentRoot /usr/web`

then an access to `http://www.my.host.com/index.html` refers to `/usr/web/index.html`.

There appears to be a bug in mod_dir which causes problems when the DocumentRoot has a trailing slash (i.e., "DocumentRoot /usr/web/") so please avoid that.

## EBCDICConvert

Syntax: EBCDICConvert On|Off[=direction] extension [extension] ...
Context: server config, virtual host, directory, .htaccess
Status: core
Override: FileInfo
Compatibility: The configurable EBCDIC conversion is only available in Apache 1.3.19 and later, and on EBCDIC based platforms.

The EBCDICConvert directive maps the given filename extensions to the specified conversion setting (`On` or `Off`). File extensions may be specified with or without a leading dot.

If the optional format `On=direction` (or `Off=direction`) is used, where direction is one of `In`, `Out` or `InOut`, then the directive only applies to the specified transfer direction (`In`: uploaded content in a PUT or POST request, `Out`: returned content in a GET or POST request, and `InOut`: conversion in both directions).
Otherwise, `InOut` (conversion in both directions) is implied.

Conversion configuration based on file extension is tested prior to configuration based on MIME type, to allow for generic MIME based rules to be overridden by a more specific file extension (several file extensions may exist for the same MIME type).

Example:
With a configuration like the following, the normal `*.html` files contain HTML text in EBCDIC encoding, while `*.ahtml` files contain HTML text in ASCII encoding:

        # *.html and *.ahtml contain HTML text:
        AddType  text/html  .html .ahtml

        # *.ahtml is not converted (contains ASCII text already):
        EBCDICConvert       Off .ahtml

        # All other text/html files presumably contain EBCDIC text:
        EBCDICConvertByType On  text/html

See also: EBCDICConvertByType and Overview of the EBCDIC Conversion Functions

## EBCDICConvertByType

Syntax: EBCDICConvertByType On|Off[=direction] mimetype [mimetype] ...
Context: server config, virtual host, directory, .htaccess
Status: core
Override: FileInfo
Compatibility: The configurable EBCDIC conversion is only available in Apache 1.3.19 and later, and on EBCDIC based platforms.

The EBCDICConvertByType directive maps the given MIME type (optionally containing wildcards) to the specified conversion setting (`On` or `Off`).

If the optional format `On=direction` (or `Off=direction`) is used, where direction is one of `In`, `Out` or `InOut`, then the directive only applies to the specified transfer direction (`In`: uploaded content in a PUT or POST request, `Out`: returned content in a GET or POST request, and `InOut`: conversion in both directions).
Otherwise, `InOut` (conversion in both directions) is implied.

Example:
A useful standard configuration should at least contain the following defaults:

        # All text documents are stored as EBCDIC files:
        EBCDICConvertByType On  text/* message/* multipart/*
        EBCDICConvertByType On  application/x-www-form-urlencoded \
                    model/vrml application/postscript
        # All other files are assumed to be binary:
        EBCDICConvertByType Off */*

If you serve ASCII documents only, for example from an NFS mounted unix server, use:

        # All documents are ASCII already:
        EBCDICConvertByType Off */*

See also: EBCDICConvert and Overview of the EBCDIC Conversion Functions

## EBCDICKludge

Syntax: EBCDICKludge On|Off
Default: `EBCDICKludge Off`
Context: server config, virtual host, directory, .htaccess
Status: core
Override: FileInfo
Compatibility: EBCDICKludge is only available in Apache 1.3.19 and later, and on EBCDIC based platforms. It is deprecated and will be withdrawn in a future version.

The EBCDICKludge is provided for the backward compatible behavior with apache versions 1.3.0 through 1.3.18. In these versions, all files with MIME types starting with "text/", "message/" or "multipart/" or with type "application/x-www-form-urlencoded" would be converted by default, all other documents were returned unconverted. Only if a MIME type "`text/x-ascii-subtype`" was configured for a certain document, the document was assumed to be in ASCII format already, and was not converted again. Instead, the "`x-ascii-`" was removed from the type, resulting in the MIME type "`text/subtype`" being returned for the document.

If the EBCDICKludge directive is set to `On`, and if none of the file extensions configured with the EBCDICConvert directive matches in the current context, then the server tests for a MIME type of the format `type/x-ascii-subtype`. If the document has such a type, then the "`x-ascii-`" substring is removed and the conversion set to `Off`. This allows for overriding the implicit assumption that all text files are stored in EBCDIC format, for example when serving documents from an NFS mounted directory with ASCII documents.
By using the EBCDICKludge, there is no way to force one of the other MIME types (e.g., model/vrml) to be treated as an EBCDIC text file. Use of the EBCDICConvertByType directive mentioned above is the preferred way to configure such a conversion. (Before Apache version 1.3.19, there was no way at all to force these binary documents to be treated as EBCDIC text files.)

See also: EBCDICConvert, EBCDICConvertByType and Overview of the EBCDIC Conversion Functions

## EnableExceptionHook directive

Syntax: EnableExceptionHook on|off
Default: `EnableExceptionHook off`
Context: server config
Status: core
Compatibility: EnableExceptionHook is available in Apache 1.3.30 and later

`EnableExceptionHook` controls whether or not an exception hook implemented by a module will be called after a child process crash. The exception hook allows modules to log diagnostic information that may help determine the cause of the crash.

## ErrorDocument directive

Syntax: ErrorDocument error-code document
Context: server config, virtual host, directory, .htaccess
Status: core
Override: FileInfo
Compatibility: The directory and .htaccess contexts are only available in Apache 1.1 and later.

In the event of a problem or error, Apache can be configured to do one of four things,

1. output a simple hardcoded error message
2. output a customized message
3. redirect to a local URL-path to handle the problem/error
4. redirect to an external URL to handle the problem/error

The first option is the default, while options 2-4 are configured using the `ErrorDocument` directive, which is followed by the HTTP response code and a message or URL.

Messages in this context begin with a single double-quote character (`"`), which does not form part of the message itself. Apache will sometimes offer additional information regarding the problem/error.

URLs can begin with a slash (/) for local URLs, or be a full URL which the client can resolve. Examples:

> `ErrorDocument 500 http://foo.example.com/cgi-bin/tester
> ErrorDocument 404 /cgi-bin/bad_urls.pl
> ErrorDocument 401 /subscription_info.html
> ErrorDocument 403 "Sorry can't allow you access today`

Note that when you specify an `ErrorDocument` that points to a remote URL (ie. anything with a method such as "http" in front of it), Apache will send a redirect to the client to tell it where to find the document, even if the document ends up being on the same server. This has several implications, the most important being that the client will not receive the original error status code, but instead will receive a redirect status code. This in turn can confuse web robots and other clients which try to determine if a URL is valid using the status code. In addition, if you use a remote URL in an `ErrorDocument 401`, the client will not know to prompt the user for a password since it will not receive the 401 status code. Therefore, if you use an "ErrorDocument 401" directive then it must refer to a local document.

Microsoft Internet Explorer (MSIE) will by default ignore server-generated error messages when they are "too small" and substitute its own "friendly" error messages. The size threshold varies depending on the type of error, but in general, if you make your error document greater than 512 bytes, then MSIE will show the server-generated error rather than masking it. More information is available in Microsoft Knowledgebase article Q294807.

See Also: documentation of customizable responses. See the HTTP specification for a complete list of the status codes and their meanings.

## ErrorLog directive

Syntax: ErrorLog file-path|syslog[:facility]
Default: `ErrorLog logs/error_log` (Unix)
Default: `ErrorLog logs/error.log` (Windows and OS/2)
Context: server config, virtual host
Status: core

The error log directive sets the name of the file to which the server will log any errors it encounters. If the file-path does not begin with a slash (/) then it is assumed to be relative to the ServerRoot. If the file-path begins with a pipe (|) then it is assumed to be a command to spawn to handle the error log.

Examples

`ErrorLog logs/vhost1.error`

or

`ErrorLog |/usr/local/bin/errorlog.pl`

Apache 1.3 and above: Using `syslog` instead of a filename enables logging via syslogd(8) if the system supports it. The default is to use syslog facility `local7`, but you can override this by using the `syslog:`facility syntax where facility can be one of the names usually documented in syslog(1).

For example:

`ErrorLog syslog`

or

`ErrorLog syslog:user`

SECURITY: See the security tips document for details on why your security could be compromised if the directory where logfiles are stored is writable by anyone other than the user that starts the server.

See also: LogLevel and Apache Log Files

## FileETag directive

Syntax: FileETag component ...
Context: server config, virtual host, directory, .htaccess
Override: FileInfo
Status: core
Compatibility: only available in Apache 1.3.23 versions and later.

The FileETag directive configures the file attributes that are used to create the ETag (entity tag) response header field when the document is based on a file. (The ETag value is used in cache management to save network bandwidth.) In Apache 1.3.22 and earlier, the ETag value was always formed from the file's inode, size, and last-modified time (mtime). The FileETag directive allows you to choose which of these -- if any -- should be used. The recognized keywords are:

INode
  The file's i-node number will be included in the calculation
MTime
  The date and time the file was last modified will be included
Size
  The number of bytes in the file will be included
All
  All available fields will be used (equivalent to '`FileETag INode MTime Size`')
None
  If a document is file-based, no ETag field will be included in the response

The INode, MTime, and Size keywords may be prefixed with either '+' or '-', which allow changes to be made to the default setting inherited from a broader scope. Any keyword appearing without such a prefix immediately and completely cancels the inherited setting.

If a directory's configuration includes '`FileETag INode MTime Size`', and a subdirectory's includes '`FileETag -INode`', the setting for that subdirectory (which will be inherited by any sub-subdirectories that don't override it) will be equivalent to '`FileETag MTime Size`'.

## <Files> directive

Syntax: <Files filename> ... </Files>
Context: server config, virtual host, .htaccess
Status: core
Compatibility: only available in Apache 1.2 and above.

The <Files> directive provides for access control by filename. It is comparable to the <Directory> directive and <Location> directives. It should be matched with a </Files> directive. The directives given within this section will be applied to any object with a basename (last component of filename) matching the specified filename. `<Files>` sections are processed in the order they appear in the configuration file, after the <Directory> sections and `.htaccess` files are read, but before <Location> sections. Note that <Files> can be nested inside <Directory> sections to restrict the portion of the filesystem they apply to.

The filename argument should include a filename, or a wild-card string, where `?' matches any single character, and `*' matches any sequences of characters. Extended regular expressions can also be used, with the addition of the `~` character. For example:

       <Files ~ "\.(gif|jpe?g|png)$">

would match most common Internet graphics formats. In Apache 1.3 and later, <FilesMatch> is preferred, however.

Note that unlike `<Directory>` and `<Location>` sections, `<Files>` sections can be used inside .htaccess files. This allows users to control access to their own files, at a file-by-file level. For example, to password protect a single file within a particular directory, you might add the following to your `.htaccess` file:

        <Files admin.cgi>
        Require group admin
        </Files>

Remember that directives apply to subdirectories as well, so this will also protect files called `admin.cgi` in subdirectories, unless specifically overridden.

(See Require for details on using the `Require` directive)

See also: How Directory, Location and Files sections work for an explanation of how these different sections are combined when a request is received

## <FilesMatch>

Syntax: <FilesMatch regex> ... </FilesMatch>
Context: server config, virtual host, .htaccess
Status: core
Compatibility: only available in Apache 1.3 and above.

The <FilesMatch> directive provides for access control by filename, just as the <Files> directive does. However, it accepts a regular expression. For example:

       <FilesMatch "\.(gif|jpe?g|png)$">

would match most common Internet graphics formats.

See also: How Directory, Location and Files sections work for an explanation of how these different sections are combined when a request is received

## Group directive

Syntax: Group unix-group
Default: `Group #-1`
Context: server config, virtual host
Status: core

The Group directive sets the group under which the server will answer requests. In order to use this directive, the stand-alone server must be run initially as root. Unix-group is one of:

A group name
  Refers to the given group by name.
# followed by a group number.
  Refers to a group by its number.

It is recommended that you set up a new group specifically for running the server. Some admins use user `nobody`, but this is not always possible or desirable.

Example:

`Group www-group`

Note: if you start the server as a non-root user, it will fail to change to the specified group, and will instead continue to run as the group of the original user.

Special note: Use of this directive in <VirtualHost> requires a properly configured suEXEC wrapper. When used inside a <VirtualHost> in this manner, only the group that CGIs are run as is affected. Non-CGI requests are still processed as the group specified in the main Group directive.

SECURITY: See User for a discussion of the security considerations.

## HostnameLookups directive

Syntax: HostnameLookups on|off|double
Default: `HostnameLookups off`
Context: server config, virtual host, directory
Status: core
Compatibility: `double` available only in Apache 1.3 and above.
Compatibility: Default was `on` prior to Apache 1.3.

This directive enables DNS lookups so that host names can be logged (and passed to CGIs/SSIs in `REMOTE_HOST`). The value `double` refers to doing double-reverse DNS. That is, after a reverse lookup is performed, a forward lookup is then performed on that result. At least one of the ip addresses in the forward lookup must match the original address. (In "tcpwrappers" terminology this is called `PARANOID`.)

Regardless of the setting, when mod_access is used for controlling access by hostname, a double reverse lookup will be performed. This is necessary for security. Note that the result of this double-reverse isn't generally available unless you set `HostnameLookups double`. For example, if only `HostnameLookups on` and a request is made to an object that is protected by hostname restrictions, regardless of whether the double-reverse fails or not, CGIs will still be passed the single-reverse result in `REMOTE_HOST`.

The default for this directive was previously `on` in versions of Apache prior to 1.3. It was changed to `off` in order to save the network traffic for those sites that don't truly need the reverse lookups done. It is also better for the end users because they don't have to suffer the extra latency that a lookup entails. Heavily loaded sites should leave this directive `off`, since DNS lookups can take considerable amounts of time. The utility logresolve, provided in the /support directory, can be used to look up host names from logged IP addresses offline.

## IdentityCheck directive

Syntax: IdentityCheck on|off
Default: `IdentityCheck off`
Context: server config, virtual host, directory
Status: core

This directive enables RFC1413-compliant logging of the remote user name for each connection, where the client machine runs identd or something similar. This information is logged in the access log.

The information should not be trusted in any way except for rudimentary usage tracking.

Note that this can cause serious latency problems accessing your server since every request requires one of these lookups to be performed. When firewalls are involved each lookup might possibly fail and add 30 seconds of latency to each hit. So in general this is not very useful on public servers accessible from the Internet.

## <IfDefine> directive

Syntax: <IfDefine [!]parameter-name> ... </IfDefine>
Default: None
Context: all
Status: Core
Compatibility: <IfDefine> is only available in 1.3.1 and later.

The <IfDefine test>...</IfDefine> section is used to mark directives that are conditional. The directives within an IfDefine section are only processed if the test is true. If test is false, everything between the start and end markers is ignored.

The test in the <IfDefine> section directive can be one of two forms:

- parameter-name
- `!`parameter-name

In the former case, the directives between the start and end markers are only processed if the parameter named parameter-name is defined. The second format reverses the test, and only processes the directives if parameter-name is not defined.

The parameter-name argument is a define as given on the `httpd` command line via `-D` parameter-, at the time the server was started.

<IfDefine> sections are nest-able, which can be used to implement simple multiple-parameter tests. Example:

      $ httpd -DReverseProxy ...

      # httpd.conf
      <IfDefine ReverseProxy>
      LoadModule rewrite_module libexec/mod_rewrite.so
      LoadModule proxy_module   libexec/libproxy.so
      </IfDefine>

## <IfModule> directive

Syntax: <IfModule [!]module-name> ... </IfModule>
Default: None
Context: all
Status: Core
Compatibility: IfModule is only available in 1.2 and later.

The <IfModule test>...</IfModule> section is used to mark directives that are conditional. The directives within an IfModule section are only processed if the test is true. If test is false, everything between the start and end markers is ignored.

The test in the <IfModule> section directive can be one of two forms:

- module name
- !module name

In the former case, the directives between the start and end markers are only processed if the module named module name is included in Apache -- either compiled in or dynamically loaded using LoadModule. The second format reverses the test, and only processes the directives if module name is not included.

The module name argument is the file name of the module, at the time it was compiled. For example, `mod_rewrite.c`.

<IfModule> sections are nest-able, which can be used to implement simple multiple-module tests.

## Include directive

Syntax: Include file-path|directory-path|wildcard-path
Context: server config
Status: Core
Compatibility: Include is only available in Apache 1.3 and later. Wildcards were introduced in version 1.3.27.

This directive allows inclusion of other configuration files from within the server configuration files.

The file path specified may be a fully qualified path (i.e. starting with a slash), or may be relative to the `ServerRoot` directory.

New in Apache 1.3.13 is the feature that if `Include` points to a directory, rather than a file, Apache will read all files in that directory, and any subdirectory, and parse those as configuration files.

By using a wildcard this can be further limited to, say, just the '*.conf' files.

Examples:

> `Include /usr/local/apache/conf/ssl.conf
> Include /usr/local/apache/conf/vhosts/`

Or, providing paths relative to your `ServerRoot` directory:

> `Include conf/ssl.conf
> Include conf/vhosts/`

Make sure that an included directory does not contain any stray files, such as editor temporary files, for example, as Apache will attempt to read them in and use the contents as configuration directives, which may cause the server to fail on start up. Running `apachectl configtest` will give you a list of the files that are being processed during the configuration check:

    root@host# apachectl configtest
     Processing config directory: /usr/local/apache/conf/vhosts
     Processing config file: /usr/local/apache/conf/vhosts/vhost1
     Processing config file: /usr/local/apache/conf/vhosts/vhost2
    Syntax OK

This will help in verifying that you are getting only the files that you intended as part of your configuration.

See also: apachectl

## KeepAlive directive

Syntax: (Apache 1.1) KeepAlive max-requests
Default: (Apache 1.1) `KeepAlive 5`
Syntax: (Apache 1.2) KeepAlive on|off
Default: (Apache 1.2) `KeepAlive On`
Context: server config
Status: Core
Compatibility: KeepAlive is only available in Apache 1.1 and later.

The Keep-Alive extension to HTTP/1.0 and the persistent connection feature of HTTP/1.1 provide long-lived HTTP sessions which allow multiple requests to be sent over the same TCP connection. In some cases this has been shown to result in an almost 50% speedup in latency times for HTML documents with many images. To enable Keep-Alive connections in Apache 1.2 and later, set `KeepAlive On`.

For HTTP/1.0 clients, Keep-Alive connections will only be used if they are specifically requested by a client. In addition, a Keep-Alive connection with an HTTP/1.0 client can only be used when the length of the content is known in advance. This implies that dynamic content such as CGI output, SSI pages, and server-generated directory listings will generally not use Keep-Alive connections to HTTP/1.0 clients. For HTTP/1.1 clients, persistent connections are the default unless otherwise specified. If the client requests it, chunked encoding will be used in order to send content of unknown length over persistent connections.

Apache 1.1 only: Set max-requests to the maximum number of requests you want Apache to entertain per connection. A limit is imposed to prevent a client from hogging your server resources. Set this to `0` to disable support. In Apache 1.2 and 1.3, this is controlled through the MaxKeepAliveRequests directive instead.

See also MaxKeepAliveRequests.

## KeepAliveTimeout directive

Syntax: KeepAliveTimeout seconds
Default: `KeepAliveTimeout 15`
Context: server config
Status: Core
Compatibility: KeepAliveTimeout is only available in Apache 1.1 and later.

The number of seconds Apache will wait for a subsequent request before closing the connection. Once a request has been received, the timeout value specified by the `Timeout` directive applies.

Setting `KeepAliveTimeout` to a high value may cause performance problems in heavily loaded servers. The higher the timeout, the more server processes will be kept occupied waiting on connections with idle clients.

## <Limit> directive

Syntax: <Limit method [method] ... > ... </Limit>
Context: any
Status: core

Access controls are normally effective for all access methods, and this is the usual desired behavior. In the general case, access control directives should not be placed within a `<limit>` section.

The purpose of the <Limit> directive is to restrict the effect of the access controls to the nominated HTTP methods. For all other methods, the access restrictions that are enclosed in the <Limit> bracket will have no effect. The following example applies the access control only to the methods POST, PUT, and DELETE, leaving all other methods unprotected:

> `<Limit POST PUT DELETE>
> Require valid-user
> </Limit>`

The method names listed can be one or more of: GET, POST, PUT, DELETE, CONNECT, OPTIONS, PATCH, PROPFIND, PROPPATCH, MKCOL, COPY, MOVE, LOCK, and UNLOCK. The method name is case-sensitive. If GET is used it will also restrict HEAD requests. The TRACE method cannot be limited.

Warning: A <LimitExcept> section should always be used in preference to a <Limit> section when restricting access, since a <LimitExcept> section provides protection against arbitrary methods.

## <LimitExcept> directive

Syntax: <LimitExcept method [method] ... > ... </LimitExcept>
Context: any
Status: core
Compatibility: Available in Apache 1.3.5 and later

<LimitExcept> and </LimitExcept> are used to enclose a group of access control directives which will then apply to any HTTP access method not listed in the arguments; i.e., it is the opposite of a <Limit> section and can be used to control both standard and nonstandard/unrecognized methods. See the documentation for <Limit> for more details.

For example:

        <LimitExcept POST GET>
        Require valid-user
        </LimitExcept>

## LimitInternalRecursion directive

Syntax: LimitInternalRecursion number [number]
Default: `LimitInternalRecursion 20`
Context: server config, virtual host
Status: core
Compatibility: LimitInternalRecursion is only available in Apache 1.3.28 and later.

An internal redirect happens, for example, when using the Action directive, which internally redirects the original request to a CGI script. A subrequest is Apache's mechanism to find out what would happen for some URI if it were requested. For example, mod_dir uses subrequests to look for the files listed in the DirectoryIndex directive.

`LimitInternalRecursion` prevents the server from crashing when entering an infinite loop of internal redirects or subrequests. Such loops are usually caused by misconfigurations.

The directive stores two different limits, which are evaluated on per-request basis. The first number is the maximum number of internal redirects, that may follow each other. The second number determines, how deep subrequests may be nested. If you specify only one number, it will be assigned to both limits. A value of `0` means "unlimited".

Example

        LimitInternalRecursion 5

## LimitRequestBody directive

Syntax: LimitRequestBody bytes
Default: `LimitRequestBody 0`
Context: server config, virtual host, directory, .htaccess
Status: core
Compatibility: LimitRequestBody is only available in Apache 1.3.2 and later.

This directive specifies the number of bytes from 0 (meaning unlimited) to 2147483647 (2GB) that are allowed in a request body.

The LimitRequestBody directive allows the user to set a limit on the allowed size of an HTTP request message body within the context in which the directive is given (server, per-directory, per-file or per-location). If the client request exceeds that limit, the server will return an error response instead of servicing the request. The size of a normal request message body will vary greatly depending on the nature of the resource and the methods allowed on that resource. CGI scripts typically use the message body for passing form information to the server. Implementations of the PUT method will require a value at least as large as any representation that the server wishes to accept for that resource.

This directive gives the server administrator greater control over abnormal client request behavior, which may be useful for avoiding some forms of denial-of-service attacks.

If, for example, you are permitting file upload to a particular location, and wich to limit the size of the uploaded file to 100K, you might use the following directive:

    LimitRequestBody 102400

## LimitRequestFields directive

Syntax: LimitRequestFields number
Default: `LimitRequestFields 100`
Context: server config
Status: core
Compatibility: LimitRequestFields is only available in Apache 1.3.2 and later.

Number is an integer from 0 (meaning unlimited) to 32767. The default value is defined by the compile-time constant `DEFAULT_LIMIT_REQUEST_FIELDS` (100 as distributed).

The LimitRequestFields directive allows the server administrator to modify the limit on the number of request header fields allowed in an HTTP request. A server needs this value to be larger than the number of fields that a normal client request might include. The number of request header fields used by a client rarely exceeds 20, but this may vary among different client implementations, often depending upon the extent to which a user has configured their browser to support detailed content negotiation. Optional HTTP extensions are often expressed using request header fields.

This directive gives the server administrator greater control over abnormal client request behavior, which may be useful for avoiding some forms of denial-of-service attacks. The value should be increased if normal clients see an error response from the server that indicates too many fields were sent in the request.

For example:

    LimitRequestFields 50

## LimitRequestFieldsize directive

Syntax: LimitRequestFieldsize bytes
Default: `LimitRequestFieldsize 8190`
Context: server config
Status: core
Compatibility: LimitRequestFieldsize is only available in Apache 1.3.2 and later.

This directive specifies the number of bytes from 0 to the value of the compile-time constant `DEFAULT_LIMIT_REQUEST_FIELDSIZE` (8190 as distributed) that will be allowed in an HTTP request header.

The LimitRequestFieldsize directive allows the server administrator to reduce the limit on the allowed size of an HTTP request header field below the normal input buffer size compiled with the server. A server needs this value to be large enough to hold any one header field from a normal client request. The size of a normal request header field will vary greatly among different client implementations, often depending upon the extent to which a user has configured their browser to support detailed content negotiation.

This directive gives the server administrator greater control over abnormal client request behavior, which may be useful for avoiding some forms of denial-of-service attacks.

For example:

    LimitRequestFieldSize 16380

Under normal conditions, the value should not be changed from the default.

## LimitRequestLine directive

Syntax: LimitRequestLine bytes
Default: `LimitRequestLine 8190`
Context: server config
Status: core
Compatibility: LimitRequestLine is only available in Apache 1.3.2 and later.

This directive sets the number of bytes from 0 to the value of the compile-time constant `DEFAULT_LIMIT_REQUEST_LINE` (8190 as distributed) that will be allowed on the HTTP request-line.

The LimitRequestLine directive allows the server administrator to reduce the limit on the allowed size of a client's HTTP request-line below the normal input buffer size compiled with the server. Since the request-line consists of the HTTP method, URI, and protocol version, the LimitRequestLine directive places a restriction on the length of a request-URI allowed for a request on the server. A server needs this value to be large enough to hold any of its resource names, including any information that might be passed in the query part of a GET request.

This directive gives the server administrator greater control over abnormal client request behavior, which may be useful for avoiding some forms of denial-of-service attacks.

For example:

    LimitRequestLine 16380

Under normal conditions, the value should not be changed from the default.

## Listen directive

Syntax: Listen [IP-address:]port
Context: server config
Status: core
Compatibility: Listen is only available in Apache 1.1 and later.

The Listen directive instructs Apache to listen to more than one IP address or port; by default it responds to requests on all IP interfaces, but only on the port given by the `Port` directive.

`Listen` can be used instead of `BindAddress` and `Port`. It tells the server to accept incoming requests on the specified port or address-and-port combination. If the first format is used, with a port number only, the server listens to the given port on all interfaces, instead of the port given by the `Port` directive. If an IP address is given as well as a port, the server will listen on the given port and interface.

Note that you may still require a `Port` directive so that URLs that Apache generates that point to your server still work.

Multiple Listen directives may be used to specify a number of addresses and ports to listen to. The server will respond to requests from any of the listed addresses and ports.

For example, to make the server accept connections on both port 80 and port 8000, use:

       Listen 80
       Listen 8000

To make the server accept connections on two specified interfaces and port numbers, use

       Listen 192.170.2.1:80
       Listen 192.170.2.5:8000

See Also: DNS Issues
See Also: Setting which addresses and ports Apache uses
See Also: Known Bugs

## ListenBacklog directive

Syntax: ListenBacklog backlog
Default: `ListenBacklog 511`
Context: server config
Status: Core
Compatibility: ListenBacklog is only available in Apache versions after 1.2.0.

The maximum length of the queue of pending connections. Generally no tuning is needed or desired, however on some systems it is desirable to increase this when under a TCP SYN flood attack. See the backlog parameter to the `listen(2)` system call.

This will often be limited to a smaller number by the operating system. This varies from OS to OS. Also note that many OSes do not use exactly what is specified as the backlog, but use a number based on (but normally larger than) what is set.

## <Location> directive

Syntax: <Location URL-path|URL> ... </Location>
Context: server config, virtual host
Status: core
Compatibility: Location is only available in Apache 1.1 and later.

The <Location> directive provides for access control by URL. It is similar to the <Directory> directive, and starts a subsection which is terminated with a </Location> directive. `<Location>` sections are processed in the order they appear in the configuration file, after the <Directory> sections and `.htaccess` files are read, and after the <Files> sections.

Note that URLs do not have to line up with the filesystem at all, it should be emphasized that <Location> operates completely outside the filesystem.

For all origin (non-proxy) requests, the URL to be matched is of the form `/path/`, and you should not include any `http://servername` prefix. For proxy requests, the URL to be matched is of the form `scheme://servername/path`, and you must include the prefix.

The URL may use wildcards In a wild-card string, `?' matches any single character, and `*' matches any sequences of characters.

Apache 1.2 and above: Extended regular expressions can also be used, with the addition of the `~` character. For example:

       <Location ~ "/(extra|special)/data">

would match URLs that contained the substring "/extra/data" or "/special/data". In Apache 1.3 and above, a new directive <LocationMatch> exists which behaves identical to the regex version of `<Location>`.

The `Location` functionality is especially useful when combined with the `SetHandler` directive. For example, to enable status requests, but allow them only from browsers at foo.com, you might use:

        <Location /status>
        SetHandler server-status
        Order Deny,Allow
        Deny from all
        Allow from .foo.com
        </Location>

Apache 1.3 and above note about / (slash): The slash character has special meaning depending on where in a URL it appears. People may be used to its behavior in the filesystem where multiple adjacent slashes are frequently collapsed to a single slash (i.e., `/home///foo` is the same as `/home/foo`). In URL-space this is not necessarily true. The `<LocationMatch>` directive and the regex version of `<Location>` require you to explicitly specify multiple slashes if that is your intention. For example, `<LocationMatch ^/abc>` would match the request URL `/abc` but not the request URL `//abc`. The (non-regex) `<Location>` directive behaves similarly when used for proxy requests. But when (non-regex) `<Location>` is used for non-proxy requests it will implicitly match multiple slashes with a single slash. For example, if you specify `<Location /abc/def>` and the request is to `/abc//def` then it will match.

See also: How Directory, Location and Files sections work for an explanation of how these different sections are combined when a request is received

## <LocationMatch>

Syntax: <LocationMatch regex> ... </LocationMatch>
Context: server config, virtual host
Status: core
Compatibility: LocationMatch is only available in Apache 1.3 and later.

The <LocationMatch> directive provides for access control by URL, in an identical manner to <Location>. However, it takes a regular expression as an argument instead of a simple string. For example:

       <LocationMatch "/(extra|special)/data">

would match URLs that contained the substring "/extra/data" or "/special/data".

See also: How Directory, Location and Files sections work for an explanation of how these different sections are combined when a request is received

## LockFile directive

Syntax: LockFile file-path
Default: `LockFile logs/accept.lock`
Context: server config
Status: core

The LockFile directive sets the path to the lockfile used when Apache is compiled with either USE_FCNTL_SERIALIZED_ACCEPT or USE_FLOCK_SERIALIZED_ACCEPT. This directive should normally be left at its default value. The main reason for changing it is if the `logs` directory is NFS mounted, since the lockfile must be stored on a local disk. The PID of the main server process is automatically appended to the filename.

SECURITY: It is best to avoid putting this file in a world writable directory such as `/var/tmp` because someone could create a denial of service attack and prevent the server from starting by creating a lockfile with the same name as the one the server will try to create.

## LogLevel directive

Syntax: LogLevel level
Default: `LogLevel warn`
Context: server config, virtual host
Status: core
Compatibility: LogLevel is only available in 1.3 or later.

LogLevel adjusts the verbosity of the messages recorded in the error logs (see ErrorLog directive). The following levels are available, in order of decreasing significance:

Level | Description | Example
--- | --- | ---
`emerg` | Emergencies - system is unusable. | "Child cannot open lock file. Exiting"
`alert` | Action must be taken immediately. | "getpwuid: couldn't determine user name from uid"
`crit` | Critical Conditions. | "socket: Failed to get a socket, exiting child"
`error` | Error conditions. | "Premature end of script headers"
`warn` | Warning conditions. | "child process 1234 did not exit, sending another SIGHUP"
`notice` | Normal but significant condition. | "httpd: caught SIGBUS, attempting to dump core in ..."
`info` | Informational. | "Server seems busy, (you may need to increase StartServers, or Min/MaxSpareServers)..."
`debug` | Debug-level messages | "Opening config file ..."

When a particular level is specified, messages from all other levels of higher significance will be reported as well. E.g., when `LogLevel info` is specified, then messages with log levels of `notice` and `warn` will also be posted.

Using a level of at least `crit` is recommended.

For example:

    LogLevel notice

NOTE: When logging to a regular file messages of the level `notice` cannot be suppressed and thus are always logged. However, this doesn't apply when logging is done using `syslog`.

## MaxClients directive

Syntax: MaxClients number
Default: `MaxClients 256`
Context: server config
Status: core

The MaxClients directive sets the limit on the number of simultaneous requests that can be supported; not more than this number of child server processes will be created. To configure more than 256 clients, you must edit the HARD_SERVER_LIMIT entry in httpd.h and recompile.

Any connection attempts over the MaxClients limit will normally be queued, up to a number based on the ListenBacklog directive. Once a child process is freed at the end of a different request, the connection will then be serviced.

## MaxKeepAliveRequests directive

Syntax: MaxKeepAliveRequests number
Default: `MaxKeepAliveRequests 100`
Context: server config
Status: core
Compatibility: Only available in Apache 1.2 and later.

The MaxKeepAliveRequests directive limits the number of requests allowed per connection when KeepAlive is on. If it is set to "`0`", unlimited requests will be allowed. We recommend that this setting be kept to a high value for maximum server performance. In Apache 1.1, this is controlled through an option to the KeepAlive directive.

For example

    MaxKeepAliveRequests 500

## MaxRequestsPerChild directive

Syntax: MaxRequestsPerChild number
Default: `MaxRequestsPerChild 0`
Context: server config
Status: core

The MaxRequestsPerChild directive sets the limit on the number of requests that an individual child server process will handle. After MaxRequestsPerChild requests, the child process will die. If MaxRequestsPerChild is 0, then the process will never expire.

Setting MaxRequestsPerChild to a non-zero limit has two beneficial effects:

- it limits the amount of memory that process can consume by (accidental) memory leakage;
- by giving processes a finite lifetime, it helps reduce the number of processes when the server load reduces.

However, on Win32, It is recommended that this be set to 0. If it is set to a non-zero value, when the request count is reached, the child process exits, and is respawned, at which time it re-reads the configuration files. This can lead to unexpected behavior if you have modified a configuration file, but are not expecting the changes to be applied yet. See also ThreadsPerChild.

NOTE: For KeepAlive requests, only the first request is counted towards this limit. In effect, it changes the behavior to limit the number of connections per child.

## MaxSpareServers directive

Syntax: MaxSpareServers number
Default: `MaxSpareServers 10`
Context: server config
Status: core

The MaxSpareServers directive sets the desired maximum number of idle child server processes. An idle process is one which is not handling a request. If there are more than MaxSpareServers idle, then the parent process will kill off the excess processes.

Tuning of this parameter should only be necessary on very busy sites. Setting this parameter to a large number is almost always a bad idea.

Note that this is the maximum number of spare servers, not the maximum total number of client requests that can be handled at one time. If you wish to limit that number, see the MaxClients directive.

This directive has no effect when used with the Apache Web server on a Microsoft Windows platform.

See also MinSpareServers, StartServers, and MaxClients.

## MinSpareServers directive

Syntax: MinSpareServers number
Default: `MinSpareServers 5`
Context: server config
Status: core

The MinSpareServers directive sets the desired minimum number of idle child server processes. An idle process is one which is not handling a request. If there are fewer than MinSpareServers idle, then the parent process creates new children at a maximum rate of 1 per second.

Tuning of this parameter should only be necessary on very busy sites. Setting this parameter to a large number is almost always a bad idea.

Note that setting this directive to some value m ensures that you will always have at least n + m `httpd` processes running when you have n active client requests.

This directive has no effect on Microsoft Windows.

See also MaxSpareServers, StartServers, and MaxClients.

## NameVirtualHost directive

Syntax: NameVirtualHost addr[:port]
Context: server config
Status: core
Compatibility: NameVirtualHost is only available in Apache 1.3 and later

The NameVirtualHost directive is a required directive if you want to configure name-based virtual hosts.

Although addr can be hostname it is recommended that you always use an IP address or wildcard, e.g.

> `NameVirtualHost 111.22.33.44`

With the NameVirtualHost directive you specify the IP address on which the server will receive requests for the name-based virtual hosts. This will usually be the address to which your name-based virtual host names resolve. In cases where a firewall or other proxy receives the requests and forwards them on a different IP address to the server, you must specify the IP address of the physical interface on the machine which will be servicing the requests. If you have multiple name-based hosts on multiple addresses, repeat the directive for each address.

Note: the "main server" and any _default_ servers will never be served for a request to a NameVirtualHost IP Address (unless for some reason you specify NameVirtualHost but then don't define any VirtualHosts for that address).

Optionally you can specify a port number on which the name-based virtual hosts should be used, e.g.

> `NameVirtualHost 111.22.33.44:8080`

In Apache 1.3.13 and greater you can specify a `*` for the addr. This creates a wildcard NameVirtualHost which will match connections to any address that isn't configured with a more specific NameVirtualHost directive or <VirtualHost> section. This is useful if you want only name-based virtual hosts and you don't want to hard-code the server's IP address into the configuration file.

See also: Apache Virtual Host documentation

## Options directive

Syntax: Options [+|-]option [[+|-]option] ...
Context: server config, virtual host, directory, .htaccess
Override: Options
Status: core

The Options directive controls which server features are available in a particular directory.

option can be set to `None`, in which case none of the extra features are enabled, or one or more of the following:

All
  All options except for MultiViews. This is the default setting.
ExecCGI
  Execution of CGI scripts is permitted.
FollowSymLinks
  The server will follow symbolic links in this directory.
  Note: even though the server follows the symlink it does not change the pathname used to match against `<Directory>` sections.
  Note: this option gets ignored if set inside a <Location> section.
Includes
  Server-side includes are permitted.
IncludesNOEXEC
  Server-side includes are permitted, but the #exec command and #exec CGI are disabled. It is still possible to #include virtual CGI scripts from ScriptAliase'd directories.
Indexes
  If a URL which maps to a directory is requested, and the there is no DirectoryIndex (e.g., index.html) in that directory, then the server will return a formatted listing of the directory.
MultiViews
  Content negotiated MultiViews are allowed.
SymLinksIfOwnerMatch
  The server will only follow symbolic links for which the target file or directory is owned by the same user id as the link.
  Note: this option gets ignored if set inside a <Location> section.

Normally, if multiple `Options` could apply to a directory, then the most specific one is taken complete; the options are not merged. However if all the options on the `Options` directive are preceded by a + or - symbol, the options are merged. Any options preceded by a + are added to the options currently in force, and any options preceded by a - are removed from the options currently in force.

For example, without any + and - symbols:

> `<Directory /web/docs>
> Options Indexes FollowSymLinks
> </Directory>
> <Directory /web/docs/spec>
> Options Includes
> </Directory>`

then only `Includes` will be set for the /web/docs/spec directory. However if the second `Options` directive uses the + and - symbols:

> `<Directory /web/docs>
> Options Indexes FollowSymLinks
> </Directory>
> <Directory /web/docs/spec>
> Options +Includes -Indexes
> </Directory>`

then the options `FollowSymLinks` and `Includes` are set for the /web/docs/spec directory.

Note: Using `-IncludesNOEXEC` or `-Includes` disables server-side includes completely regardless of the previous setting.

The default in the absence of any other settings is `All`.

## PidFile directive

Syntax: PidFile file-path
Default: `PidFile logs/httpd.pid`
Context: server config
Status: core

The PidFile directive sets the file to which the server records the process id of the daemon. If the filename does not begin with a slash (/) then it is assumed to be relative to the ServerRoot. The PidFile is only used in standalone mode.

It is often useful to be able to send the server a signal, so that it closes and then reopens its ErrorLog and TransferLog, and re-reads its configuration files. This is done by sending a SIGHUP (kill -1) signal to the process id listed in the PidFile.

The PidFile is subject to the same warnings about log file placement and security.

## Port directive

Syntax: Port number
Default: `Port 80`
Context: server config
Status: core

Number is a number from 0 to 65535; some port numbers (especially below 1024) are reserved for particular protocols. See `/etc/services` for a list of some defined ports; the standard port for the http protocol is 80.

The Port directive has two behaviors, the first of which is necessary for NCSA backwards compatibility (and which is confusing in the context of Apache).

- In the absence of any Listen or BindAddress directives specifying a port number, a Port directive given in the "main server" (i.e., outside any <VirtualHost> section) sets the network port on which the server listens. If there are any Listen or BindAddress directives specifying `:number` then Port has no effect on what address the server listens at.
- The Port directive sets the `SERVER_PORT` environment variable (for CGI and SSI), and is used when the server must generate a URL that refers to itself (for example when creating an external redirect to itself). This behavior is modified by UseCanonicalName.

The primary behavior of Port should be considered to be similar to that of the ServerName directive. The ServerName and Port together specify what you consider to be the canonical address of the server. (See also UseCanonicalName.)

Port 80 is one of Unix's special ports. All ports numbered below 1024 are reserved for system use, i.e., regular (non-root) users cannot make use of them; instead they can only use higher port numbers. To use port 80, you must start the server from the root account. After binding to the port and before accepting requests, Apache will change to a low privileged user as set by the User directive.

If you cannot use port 80, choose any other unused port. Non-root users will have to choose a port number higher than 1023, such as 8000.

SECURITY: if you do start the server as root, be sure not to set User to root. If you run the server as root whilst handling connections, your site may be open to a major security attack.

## ProtocolReqCheck directive

Syntax: ProtocolReqCheck on|off
Default: `ProtocolReqCheck on`
Context: server config
Status: core
Compatibility: ProtocolReqCheck is only available in Apache 1.3.27 and later.

This directive enables strict checking of the Protocol field in the Request line. Versions of Apache prior to 1.3.26 would silently accept bogus Protocols (such as `HTTP-1.1`) and assume `HTTP/1.0`. Instead, now the Protocol field must be valid. If the pre-1.3.26 behavior is desired or required, it can be enabled via setting `ProtocolReqCheck off`.

## Require directive

Syntax: Require entity-name [entity-name] ...
Context: directory, .htaccess
Override: AuthConfig
Status: core

This directive selects which authenticated users can access a resource. The allowed syntaxes are:

- Require user userid [userid] ...

  Only the named users can access the resource.

- Require group group-name [group-name] ...

  Only users in the named groups can access the resource.

- Require valid-user

  All valid users can access the resource.

- file-owner

  Only the user, whose name matches the system's name for the file owner, can access the resource.
  [Available after Apache 1.3.20]

- file-group

  Only the members of the group, whose name matches the system's name of the file owner group, can access the resource.
  [Available after Apache 1.3.20]

Require must be accompanied by AuthName and AuthType directives, and directives such as AuthUserFile and AuthGroupFile (to define users and groups) in order to work correctly. Example:

> `AuthType Basic
> AuthName "Restricted Directory"
> AuthUserFile /web/users
> AuthGroupFile /web/groups
> Require group admin
> `

Access controls which are applied in this way are effective for all methods. This is what is normally desired. If you wish to apply access controls only to specific methods, while leaving other methods unprotected, then place the `Require` statement into a <Limit> section

See also Satisfy and mod_access.

## ResourceConfig directive

Syntax: ResourceConfig file-path|directory-path|wildcard-path
Default: `ResourceConfig conf/srm.conf`
Context: server config, virtual host
Status: core
Compatibility: The ability to specify a directory, rather than a file name, is only available in Apache 1.3.13 and later.

The server will read this file for more directives after reading the httpd.conf file. File-path is relative to the ServerRoot. This feature can be disabled using:

> `ResourceConfig /dev/null`

Or, on Win32 servers,

> `ResourceConfig nul`

Historically, this file contained most directives except for server configuration directives and <Directory> sections; in fact it can now contain any server directive allowed in the server config context. However, since Apache version 1.3.4, the default `srm.conf` file which ships with Apache contains only comments, and all directives are placed in the main server configuration file, `httpd.conf`.

If `ResourceConfig` points to a directory, rather than a file, Apache will read all files in that directory, and any subdirectory, and parse those as configuration files.

Alternatively you can use a wildcard to limit the scope; i.e to only *.conf files.

Note that by default any file in the specified directory will be loaded as a configuration file.

So make sure that you don't have stray files in this directory by mistake, such as temporary files created by your editor, for example.

See also AccessConfig.

## RLimitCPU directive

Syntax: RLimitCPU number|max [number|max]
Default: Unset; uses operating system defaults
Context: server config, virtual host
Status: core
Compatibility: RLimitCPU is only available in Apache 1.2 and later

Takes 1 or 2 parameters. The first parameter sets the soft resource limit for all processes and the second parameter sets the maximum resource limit. Either parameter can be a number, or `max` to indicate to the server that the limit should be set to the maximum allowed by the operating system configuration. Raising the maximum resource limit requires that the server is running as root, or in the initial startup phase.

This applies to processes forked off from Apache children servicing requests, not the Apache children themselves. This includes CGI scripts and SSI exec commands, but not any processes forked off from the Apache parent such as piped logs.

CPU resource limits are expressed in seconds per process.

See also RLimitMEM or RLimitNPROC.

## RLimitMEM directive

Syntax: RLimitMEM number|max [number|max]
Default: Unset; uses operating system defaults
Context: server config, virtual host
Status: core
Compatibility: RLimitMEM is only available in Apache 1.2 and later

Takes 1 or 2 parameters. The first parameter sets the soft resource limit for all processes and the second parameter sets the maximum resource limit. Either parameter can be a number, or `max` to indicate to the server that the limit should be set to the maximum allowed by the operating system configuration. Raising the maximum resource limit requires that the server is running as root, or in the initial startup phase.

This applies to processes forked off from Apache children servicing requests, not the Apache children themselves. This includes CGI scripts and SSI exec commands, but not any processes forked off from the Apache parent such as piped logs.

Memory resource limits are expressed in bytes per process.

See also RLimitCPU or RLimitNPROC.

## RLimitNPROC directive

Syntax: RLimitNPROC number|max [number|max]
Default: Unset; uses operating system defaults
Context: server config, virtual host
Status: core
Compatibility: RLimitNPROC is only available in Apache 1.2 and later

Takes 1 or 2 parameters. The first parameter sets the soft resource limit for all processes and the second parameter sets the maximum resource limit. Either parameter can be a number, or `max` to indicate to the server that the limit should be set to the maximum allowed by the operating system configuration. Raising the maximum resource limit requires that the server is running as root, or in the initial startup phase.

This applies to processes forked off from Apache children servicing requests, not the Apache children themselves. This includes CGI scripts and SSI exec commands, but not any processes forked off from the Apache parent such as piped logs.

Process limits control the number of processes per user.

Note: If CGI processes are not running under userids other than the web server userid, this directive will limit the number of processes that the server itself can create. Evidence of this situation will be indicated by cannot fork messages in the error_log.

See also RLimitMEM or RLimitCPU.

## Satisfy directive

Syntax: Satisfy any|all
Default: Satisfy all
Context: directory, .htaccess
Status: core
Compatibility: Satisfy is only available in Apache 1.2 and later

Access policy if both `Allow` and `Require` used. The parameter can be either 'all' or 'any'. This directive is only useful if access to a particular area is being restricted by both username/password and client host address. In this case the default behavior ("all") is to require that the client passes the address access restriction and enters a valid username and password. With the "any" option the client will be granted access if they either pass the host restriction or enter a valid username and password. This can be used to password restrict an area, but to let clients from particular addresses in without prompting for a password.

See also Require and Allow.

## ScoreBoardFile directive

Syntax: ScoreBoardFile file-path
Default: `ScoreBoardFile logs/apache_status`
Context: server config
Status: core

The ScoreBoardFile directive is required on some architectures to place a file that the server will use to communicate between its children and the parent. The easiest way to find out if your architecture requires a scoreboard file is to run Apache and see if it creates the file named by the directive. If your architecture requires it then you must ensure that this file is not used at the same time by more than one invocation of Apache.

If you have to use a ScoreBoardFile then you may see improved speed by placing it on a RAM disk. But be careful that you heed the same warnings about log file placement and security.

Apache 1.2 and above:

Linux 1.x users might be able to add `-DHAVE_SHMGET -DUSE_SHMGET_SCOREBOARD` to the `EXTRA_CFLAGS` in your `Configuration`. This might work with some 1.x installations, but won't work with all of them. (Prior to 1.3b4, `HAVE_SHMGET` would have sufficed.)

SVR4 users should consider adding `-DHAVE_SHMGET -DUSE_SHMGET_SCOREBOARD` to the `EXTRA_CFLAGS` in your `Configuration`. This is believed to work, but we were unable to test it in time for 1.2 release. (Prior to 1.3b4, `HAVE_SHMGET` would have sufficed.)

See Also: Stopping and Restarting Apache

## ScriptInterpreterSource directive

Syntax: ScriptInterpreterSource registry|script
Default: `ScriptInterpreterSource script`
Context: directory, .htaccess
Status: core (Windows only)

This directive is used to control how Apache 1.3.5 and later finds the interpreter used to run CGI scripts. The default technique is to use the interpreter pointed to by the #! line in the script. Setting ScriptInterpreterSource registry will cause the Windows Registry to be searched using the script file extension (e.g., .pl) as a search key.

## SendBufferSize directive

Syntax: SendBufferSize bytes
Context: server config
Status: core

The server will set the TCP buffer size to the number of bytes specified. Very useful to increase past standard OS defaults on high speed high latency (i.e., 100ms or so, such as transcontinental fast pipes)

## ServerAdmin directive

Syntax: ServerAdmin email-address
Context: server config, virtual host
Status: core

The ServerAdmin sets the e-mail address that the server includes in any error messages it returns to the client.

It may be worth setting up a dedicated address for this, e.g.

> `ServerAdmin www-admin@foo.bar.com`

as users do not always mention that they are talking about the server!

## ServerAlias directive

Syntax: ServerAlias hostname [hostname] ...
Context: virtual host
Status: core
Compatibility: ServerAlias is only available in Apache 1.1 and later.

The ServerAlias directive sets the alternate names for a host, for use with name-based virtual hosts.

Example:

        <VirtualHost *>
        ServerName server.domain.com
        ServerAlias server server2.domain.com server2
        ...
        </VirtualHost>

See also: Apache Virtual Host documentation

## ServerName directive

Syntax: ServerName fully-qualified-domain-name
Context: server config, virtual host
Status: core

The ServerName directive sets the hostname of the server; this is used when creating redirection URLs. If it is not specified, then the server attempts to deduce it from its own IP address; however this may not work reliably, or may not return the preferred hostname. For example:

> `ServerName www.example.com`

would be used if the canonical (main) name of the actual machine were `simple.example.com`.

If you are using name-based virtual hosts, the `ServerName` inside a `<VirtualHost>` section specifies what hostname must appear in the request's `Host:` header to match this virtual host.

See Also:
DNS Issues
Apache virtual host documentation
UseCanonicalName
NameVirtualHost
ServerAlias

## ServerPath directive

Syntax: ServerPath directory-path
Context: virtual host
Status: core
Compatibility: ServerPath is only available in Apache 1.1 and later.

The ServerPath directive sets the legacy URL pathname for a host, for use with name-based virtual hosts.

See also: Apache Virtual Host documentation

## ServerRoot directive

Syntax: ServerRoot directory-path
Default: `ServerRoot /usr/local/apache`
Context: server config
Status: core

The ServerRoot directive sets the directory in which the server lives. Typically it will contain the subdirectories `conf/` and `logs/`. Relative paths for other configuration files are taken as relative to this directory.

See also the `-d` option to httpd.

See also the security tips for information on how to properly set permissions on the ServerRoot.

## ServerSignature directive

Syntax: ServerSignature On|Off|EMail
Default: `ServerSignature Off`
Context: server config, virtual host, directory, .htaccess
Status: core
Compatibility: ServerSignature is only available in Apache 1.3 and later.

The ServerSignature directive allows the configuration of a trailing footer line under server-generated documents (error messages, mod_proxy ftp directory listings, mod_info output, ...). The reason why you would want to enable such a footer line is that in a chain of proxies, the user often has no possibility to tell which of the chained servers actually produced a returned error message.
The `Off` setting, which is the default, suppresses the error line (and is therefore compatible with the behavior of Apache-1.2 and below). The `On` setting simply adds a line with the server version number and ServerName of the serving virtual host, and the `EMail` setting additionally creates a "mailto:" reference to the ServerAdmin of the referenced document.

## ServerTokens directive

Syntax: ServerTokens Minimal|ProductOnly|OS|Full
Default: `ServerTokens Full`
Context: server config
Status: core
Compatibility: ServerTokens is only available in Apache 1.3 and later; the `ProductOnly` keyword is only available in versions later than 1.3.12

This directive controls whether `Server` response header field which is sent back to clients includes a description of the generic OS-type of the server as well as information about compiled-in modules.

`ServerTokens Prod[uctOnly]`
  Server sends (e.g.): `Server: Apache`
`ServerTokens Min[imal]`
  Server sends (e.g.): `Server: Apache/1.3.0`
`ServerTokens OS`
  Server sends (e.g.): `Server: Apache/1.3.0 (Unix)`
`ServerTokens Full` (or not specified)
  Server sends (e.g.): `Server: Apache/1.3.0 (Unix) PHP/3.0 MyMod/1.2`

This setting applies to the entire server, and cannot be enabled or disabled on a virtualhost-by-virtualhost basis.

## ServerType directive

Syntax: ServerType type
Default: `ServerType standalone`
Context: server config
Status: core

The ServerType directive sets how the server is executed by the system. Type is one of

inetd
  The server will be run from the system process inetd; the command to start the server is added to `/etc/inetd.conf`
standalone
  The server will run as a daemon process; the command to start the server is added to the system startup scripts. (`/etc/rc.local` or `/etc/rc3.d/...`.)

Inetd is the lesser used of the two options. For each http connection received, a new copy of the server is started from scratch; after the connection is complete, this program exits. There is a high price to pay per connection, but for security reasons, some admins prefer this option. Inetd mode is no longer recommended and does not always work properly. Avoid it if at all possible.

Standalone is the most common setting for ServerType since it is far more efficient. The server is started once, and services all subsequent connections. If you intend running Apache to serve a busy site, standalone will probably be your only option.

## ShmemUIDisUser directive

Syntax: ShmemUIDisUser on|off
Default: `ShmemUIDisUser off`
Context: server config
Status: core
Compatibility: ShmemUIDisUser directive is only available in Apache 1.3.27 and later.

The ShmemUIDisUser directive controls whether Apache will change the `uid` and `gid` ownership of System V shared memory based scoreboards to the server settings of User and Group. Releases of Apache up to 1.3.26 would do this by default. Since the child processes are already attached to the shared memory segment, this is not required for normal usage of Apache and so to prevent possible abuse, Apache will no longer do that. The old behavior may be required for special cases, however, which can be implemented by setting this directive to `on`.

This directive has no effect on non-System V based scoreboards, such as `mmap`.

## StartServers directive

Syntax: StartServers number
Default: `StartServers 5`
Context: server config
Status: core

The StartServers directive sets the number of child server processes created on startup. As the number of processes is dynamically controlled depending on the load, there is usually little reason to adjust this parameter.

When running under Microsoft Windows, this directive has no effect. There is always one child which handles all requests. Within the child requests are handled by separate threads. The ThreadsPerChild directive controls the maximum number of child threads handling requests, which will have a similar effect to the setting of `StartServers` on Unix.

See also MinSpareServers and MaxSpareServers.

## ThreadsPerChild

Syntax: ThreadsPerChild number
Default: `ThreadsPerChild 50`
Context: server config
Status: core (Windows, NetWare)
Compatibility: Available only with Apache 1.3 and later with Windows

This directive tells the server how many threads it should use. This is the maximum number of connections the server can handle at once; be sure and set this number high enough for your site if you get a lot of hits.

This directive has no effect on Unix systems. Unix users should look at StartServers and MaxRequestsPerChild.

## ThreadStackSize

Syntax: ThreadStackSize number
Default: `ThreadStackSize 65536`
Context: server config
Status: core (NetWare)
Compatibility: Available only with Apache 1.3 and later with NetWare

This directive tells the server what stack size to use for each of the running threads. If you ever get a stack overflow you will need to bump this number to a higher setting.

This directive has no effect on other systems.

## TimeOut directive

Syntax: TimeOut number
Default: `TimeOut 300`
Context: server config
Status: core

The TimeOut directive currently defines the amount of time Apache will wait for three things:

1. The total amount of time it takes to receive a GET request.
2. The amount of time between receipt of TCP packets on a POST or PUT request.
3. The amount of time between ACKs on transmissions of TCP packets in responses.

We plan on making these separately configurable at some point down the road. The timer used to default to 1200 before 1.2, but has been lowered to 300 which is still far more than necessary in most situations. It is not set any lower by default because there may still be odd places in the code where the timer is not reset when a packet is sent.

## TraceEnable

Syntax: TraceEnable [on|off|extended]
Default: `TraceEnable on`
Context: server config
Status: core (Windows, NetWare)
Compatibility: Available only in Apache 1.3.34, 2.0.55 and later

This directive overrides the behavior of TRACE for both the core server and mod_proxy. The default `TraceEnable on` permits TRACE requests per RFC 2616, which disallows any request body to accompany the request. `TraceEnable off` causes the core server and mod_proxy to return a 405 FORBIDDEN error to the client.

Finally, for testing and diagnostic purposes only, request bodies may be allowed using the non-compliant `TraceEnable extended` directive. The core (as an origin server) will restrict the request body to 64k (plus 8k for chunk headers if Transfer-Encoding: chunked is used). The core will reflect the full headers and all chunk headers with the request body. As a proxy server, the request body is not restricted to 64k. At this time the Apache 1.3 mod_proxy does not permit chunked request bodies for any request, including the extended TRACE request.

## UseCanonicalName directive

Syntax: UseCanonicalName on|off|dns
Default: `UseCanonicalName on`
Context: server config, virtual host, directory
Override: Options
Compatibility: UseCanonicalName is only available in Apache 1.3 and later

In many situations Apache has to construct a self-referential URL. That is, a URL which refers back to the same server. With `UseCanonicalName on` (and in all versions prior to 1.3) Apache will use the ServerName and Port directives to construct the canonical name for the server. This name is used in all self-referential URLs, and for the values of `SERVER_NAME` and `SERVER_PORT` in CGIs.

For example, if ServerName is set to `www.example.com` and Port is set to `9090`, then the canonical name of the server is `www.example.com:9090`. In the event that `Port` has its default value of `80`, the `:80` is omitted from the canonical name.

With `UseCanonicalName off` Apache will form self-referential URLs using the hostname and port supplied by the client if any are supplied (otherwise it will use the canonical name, as defined above). These values are the same that are used to implement name based virtual hosts, and are available with the same clients. The CGI variables `SERVER_NAME` and `SERVER_PORT` will be constructed from the client supplied values as well.

An example where this may be useful is on an intranet server where you have users connecting to the machine using short names such as `www`. You'll notice that if the users type a shortname, and a URL which is a directory, such as `http://www/splat`, without the trailing slash then Apache will redirect them to `http://www.domain.com/splat/`. If you have authentication enabled, this will cause the user to have to authenticate twice (once for `www` and once again for `www.domain.com` -- see the FAQ on this subject for more information). But if `UseCanonicalName` is set off, then Apache will redirect to `http://www/splat/`.

There is a third option, `UseCanonicalName DNS`, which is intended for use with mass IP-based virtual hosting to support ancient clients that do not provide a `Host:` header. With this option Apache does a reverse DNS lookup on the server IP address that the client connected to in order to work out self-referential URLs.

Warning: if CGIs make assumptions about the values of `SERVER_NAME` they may be broken by this option. The client is essentially free to give whatever value they want as a hostname. But if the CGI is only using `SERVER_NAME` to construct self-referential URLs then it should be just fine.

See also: ServerName, Port

## User directive

Syntax: User unix-userid
Default: `User #-1`
Context: server config, virtual host
Status: core

The User directive sets the userid as which the server will answer requests. In order to use this directive, the standalone server must be run initially as root. Unix-userid is one of:

A username
  Refers to the given user by name.
# followed by a user number.
  Refers to a user by their number.

The user should have no privileges which result in it being able to access files which are not intended to be visible to the outside world, and similarly, the user should not be able to execute code which is not meant for httpd requests. It is recommended that you set up a new user and group specifically for running the server. Some admins use user `nobody`, but this is not always possible or desirable. For example mod_proxy's cache, when enabled, must be accessible to this user (see the `CacheRoot` directive).

Notes: If you start the server as a non-root user, it will fail to change to the lesser privileged user, and will instead continue to run as that original user. If you do start the server as root, then it is normal for the parent process to remain running as root.

Special note: Use of this directive in <VirtualHost> requires a properly configured suEXEC wrapper. When used inside a <VirtualHost> in this manner, only the user that CGIs are run as is affected. Non-CGI requests are still processed with the user specified in the main User directive.

SECURITY: Don't set User (or Group) to `root` unless you know exactly what you are doing, and what the dangers are.

## <VirtualHost> directive

Syntax: <VirtualHost addr[:port] [addr[:port]] ...> ... </VirtualHost>
Context: server config
Status: Core.
Compatibility: Non-IP address-based Virtual Hosting only available in Apache 1.1 and later.
Compatibility: Multiple address support only available in Apache 1.2 and later.

<VirtualHost> and </VirtualHost> are used to enclose a group of directives which will apply only to a particular virtual host. Any directive which is allowed in a virtual host context may be used. When the server receives a request for a document on a particular virtual host, it uses the configuration directives enclosed in the <VirtualHost> section. Addr can be

- The IP address of the virtual host
- A fully qualified domain name for the IP address of the virtual host.

Example:

> `<VirtualHost 10.1.2.3>
> ServerAdmin webmaster@host.foo.com
> DocumentRoot /www/docs/host.foo.com
> ServerName host.foo.com
> ErrorLog logs/host.foo.com-error_log
> TransferLog logs/host.foo.com-access_log
> </VirtualHost>`

Each VirtualHost must correspond to a different IP address, different port number or a different host name for the server, in the former case the server machine must be configured to accept IP packets for multiple addresses. (If the machine does not have multiple network interfaces, then this can be accomplished with the `ifconfig alias` command (if your OS supports it), or with kernel patches like VIF (for SunOS(TM) 4.1.x)).

You can specify more than one IP address. This is useful if a machine responds to the same name on two different interfaces. For example, if you have a VirtualHost that is available to hosts on an internal (intranet) as well as external (internet) network. Example:

> `<VirtualHost 192.168.1.2 204.255.176.199>
> DocumentRoot /www/docs/host.foo.com
> ServerName host.foo.com
> ServerAlias host
> </VirtualHost>`

The special name `_default_` can be specified in which case this virtual host will match any IP address that is not explicitly listed in another virtual host. In the absence of any _default_ virtual host the "main" server config, consisting of all those definitions outside any VirtualHost section, is used when no match occurs.

You can specify a `:port` to change the port that is matched. If unspecified then it defaults to the same port as the most recent `Port` statement of the main server. You may also specify `:*` to match all ports on that address. (This is recommended when used with `_default_`.)

SECURITY: See the security tips document for details on why your security could be compromised if the directory where logfiles are stored is writable by anyone other than the user that starts the server.

NOTE: The use of <VirtualHost> does not affect what addresses Apache listens on. You may need to ensure that Apache is listening on the correct addresses using either BindAddress or Listen.

See also: Apache Virtual Host documentation
See also: Warnings about DNS and Apache
See also: Setting which addresses and ports Apache uses
See also: How Directory, Location and Files sections work for an explanation of how these different sections are combined when a request is received

### Apache HTTP Server Version 1.3